<?php
/*
 * Copyright (C) 2018 josh.north@point808.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

    ini_set('session.gc_maxlifetime', 24*60*60);                                // MIN SESSION
    ini_set('session.gc_probability', 1);                                       // GC RATES
    ini_set('session.gc_divisor', 100);                                         // TIMES
    ini_set('session.use_cookies', '1');
    ini_set('session.use_only_cookies', '1');
    ini_set('session.cookie_secure', '0');
    ini_set('session.cookie_httponly', '0');
    ini_set('session.cookie_samesite', 'Lax');
    session_save_path('.tmp');                                                  // TEMP
    session_start();                                                            // START
    require_once __DIR__ . '/autoload.php';                                     // AUTOLOAD
    use App\LobbySIO\Misc\Csrf;                                        // ANTICSRF
    $StaticFunctions = new \App\LobbySIO\Misc\StaticFunctions();                // DEFAULT CLASSES
    $SiteInfo = new \App\LobbySIO\Database\SiteInfo();
    $Users = new \App\LobbySIO\Database\Users();
    if (isset($_SESSION['user_id'])) {                                          // LOGGED IN? GET USER OBJECT
        $session_user = $Users->getUserInfo($_SESSION['user_id'], "1", "0"); }
    if (isset($session_user)) {                                                 // GET UID OR SET TO KIOSK
        $uid = $session_user["0"]["users_id"];} else { $uid = "2"; }
    $app_disp_lang = filter_input(INPUT_COOKIE, 'app_disp_lang');               // SETUP LANGUAGE
    if(!isset($app_disp_lang)) {
        $app_disp_lang=$StaticFunctions->getDefaultLanguage(); }
    $siteidcookie = filter_input(INPUT_COOKIE, 'app_site');                     // SETUP SITE
    foreach($SiteInfo->getSite("0", $uid, "0", "0") as $arr) {
        $lookup_array[$arr['sites_id']]=1; }
        if(isset($lookup_array[$siteidcookie])) {
            $siteid = $siteidcookie; } else { $siteid = "1"; }
        if(!isset($siteid)) { $siteid="1"; }
    $Translate = new \App\LobbySIO\Language\Translate($app_disp_lang);          // SETUP TRANSLATOR
    $transLang =  $Translate->userLanguage();
    $VisitTypeInfo = new \App\LobbySIO\Database\VisitTypeInfo();
    $VisitActions = new \App\LobbySIO\Database\VisitActions();
    $app_current_pagename = $transLang['SIGNIN'];                               // PAGE SETUP
    $app_current_pageicon = '<i class="fas fa-file-signature"></i> ';
    require_once("inc/header.inc.php");
    if ($StaticFunctions->getSessionStatus() == true) {                         // CHECK STATUS
        header('Location: index.php');                                          // ELSE HOME
    } else {
      header("X-Frame-Options: SAMEORIGIN");
      header("X-Content-Type-Options: nosniff");
      //header("Content-Security-Policy: script-src 'self' 'unsafe-inline'; script-src-elem 'self'; script-src-attr 'self'; style-src 'self'; style-src-elem 'self'; style-src-attr 'self'; img-src 'self'; connect-src 'self'; frame-src 'self'; font-src 'self'; media-src 'self'; object-src 'self'; manifest-src 'self'; worker-src 'self'; prefetch-src 'self'; form-action 'self'; frame-ancestors 'self'; default-src 'self'", false);
      if (!empty($_GET['a'])) {
        echo '<pre>' . print_r($_POST, true) . '</pre>';
        echo 'Verification has been : ' . (Csrf::verifyToken('home') ? 'successful' : 'unsuccessful');
      }
    ?>



<?php                                                                           // FILTER POSTED DATA
$form_data = filter_input_array(INPUT_POST, [
  'fd_formAction' => (string)FILTER_SANITIZE_STRING,
  'fd_siteId' => (int)FILTER_VALIDATE_INT,
  'fd_isVendor' => (int)FILTER_VALIDATE_INT,
  'fd_firstName' => (string)FILTER_SANITIZE_STRING,
  'fd_lastName' => (string)FILTER_SANITIZE_STRING,
  'fd_carNum' => (string)FILTER_SANITIZE_STRING,
  'fd_ssaNum' => (string)FILTER_SANITIZE_STRING,
  'fd_visitorCompany' => (string)FILTER_SANITIZE_STRING,
  'fd_vendorContact1' => (string)FILTER_SANITIZE_STRING,
  'fd_vendorContact2' => (string)FILTER_SANITIZE_STRING,
  'fd_workStartTime' => (string)FILTER_SANITIZE_STRING,
  'fd_workEndTime' => (string)FILTER_SANITIZE_STRING,
  'fd_clientImpacted' => (string)FILTER_SANITIZE_STRING,
  'fd_visitType' => (int)FILTER_VALIDATE_INT,
  'fd_escortRequired' => (int)FILTER_VALIDATE_INT,
  'fd_visitorSignature' => (string)FILTER_SANITIZE_STRING,
  'fd_escortSignature' => (string)FILTER_SANITIZE_STRING,
  'fd_escortName' => (string)FILTER_SANITIZE_STRING
]);
if (empty($form_data['fd_carNum'])) { $carnum="";} else {$carnum=$form_data['fd_carNum'];}
if (empty($form_data['fd_ssaNum'])) { $ssanum="";} else {$ssanum=$form_data['fd_ssaNum'];}
if (empty($form_data['fd_isVendor'])) { $isvendor="0";} else {$isvendor=$form_data['fd_isVendor'];}
if (empty($form_data['fd_vendorContact1'])) { $db_vendorinfo_contact1="";} else {$db_vendorinfo_contact1=$form_data['fd_vendorContact1'];}
if (empty($form_data['fd_vendorContact2'])) { $db_vendorinfo_contact2="";} else {$db_vendorinfo_contact2=$form_data['fd_vendorContact2'];}
if (empty($form_data['fd_workStartTime'])) { $db_vendorinfo_workstart="";} else {$db_vendorinfo_workstart=$form_data['fd_workStartTime'];}
if (empty($form_data['fd_workEndTime'])) { $db_vendorinfo_workend="";} else {$db_vendorinfo_workend=$form_data['fd_workEndTime'];}
if (empty($form_data['fd_clientImpacted'])) { $db_vendorinfo_customerimpacted="";} else {$db_vendorinfo_customerimpacted=$form_data['fd_clientImpacted'];}
$visitid = $VisitActions->newVisit($form_data['fd_firstName'], $form_data['fd_lastName'], $form_data['fd_visitorCompany'], $form_data['fd_visitType'], $StaticFunctions->getUTC(), $form_data['fd_visitorSignature'], $form_data['fd_siteId'], "1", $form_data['fd_escortSignature'], $form_data['fd_escortName'], $carnum, $ssanum, $isvendor);
if($form_data['fd_isVendor'] === (int)"1") {
  $vendorid = $VisitActions->setInfoVendorVisitNew($visitid, $db_vendorinfo_contact1, $db_vendorinfo_contact2, $db_vendorinfo_workstart, $db_vendorinfo_workend, $db_vendorinfo_customerimpacted);
}
if(!empty($form_data['fd_formAction'])){                                        // SET INITIAL STAGE
  $form_data['fd_formAction'] = 'readytosubmit';
}
?>

<!-- CONTENT -->

<?php if($form_data['fd_formAction'] === "readytosubmit"){ ?>

  <div class="container">
    <div class="row row-cols-1">
      <div class="col d-grid gap-2">
        <h2><i class="fas fa-sign-in-alt"></i> <?=$transLang['SIGNIN_THANKYOU']?></h2>
      </div>
    </div>
    <div class="row row-cols-1">
      <div class="col d-grid gap-2">
        <table class="table table-striped">
          <thead class="thead-dark">
            <tr>
              <th><?=$transLang['TIMEREASON']?></th><th><?=$transLang['COMPANY']?></th><th><?=$transLang['NAME']?></th><th><?=$transLang['ESCORT']?></th>
            </tr>
          </thead>
          <tbody>
            <tr>
              <td><?php echo $timenow; ?><br><?php echo $transLang[$VisitTypeInfo->getInfoVisitType("%", $form_data['fd_visitType'])[0]["visittypes_name"]]; ?></td><td><?=$form_data['fd_visitorCompany']?></td><td><?=$form_data['fd_lastName']?>, <?=$form_data['fd_firstName']?><br><img src="<?=$form_data['fd_visitorSignature']?>" width="200" height="50" /></td><td><?php if (!empty($form_data['fd_escortName'])): echo $form_data['fd_escortName']; endif; ?><br /><?php if (!empty($form_data['fd_escortSignature'])): ?><img src="<?=$form_data['fd_escortSignature']?>" width="200" height="50" /><?php endif; ?></td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <div class="row row-cols-1">
      <div class="col d-grid gap-2">
<?php if($SiteInfo->getSite($form_data['fd_siteId'], $uid, "0", "0")[0]["sites_region"] == "US") { ?>
        <p><?=$transLang['ACKNOWLEDGEMENT']?></p>
<?php } ?>
        <p><?=$transLang['GDPR_TEXT']?><p>
      </div>
    </div>
    <div class="row row-cols-1">
      <div class="col d-grid gap-2">
        <a href="index.php" class="btn btn-success btn-lg btn-block" tabindex="-1" role="button" aria-disabled="true">&nbsp<br /><?=$transLang['STR_COMMON_HOME']?><br />&nbsp</a>
      </div>
    </div>
 <!-- END CONTENT -->
<?php }else{ ?>
<!-- START ERROR -->
  <div class="container">
    <div class="row row-cols-1">
      <div class="col d-grid gap-2">
        <h2><?=$transLang['NOSIGNIN']?></h2>
      </div>
    </div>
  </div>
<!-- END ERROR -->
<?php } ?>

<?php } require_once("inc/footer.inc.php");
